package frfs2;

import java.util.*;
import java.io.*;
import search.*;
import set.FuzzySet;
import set.Subset;

public final class frfs {
	static int command = -1;
	static final int BOUNDARY = 1;
	static final int LOWER = 2;
	static final int DISCERNIBILITY = 3;
	static final int ISREDUCT = 4;
	static final int CORE = 5;
	static final int TEST = 6;
	static final int ENTROPY_REDUCT = 7;
	static final int GAIN_RATIO = 8;
	static final int DELTA = 9;
	static final int CORNELIS = 10;
	static final int VQRS = 11;
	static final int ORIGINAL_FRFS = 12;
	static final int VQRS2 = 13;
	static final int BOUNDARY_ENTROPY = 14;
	static final int INTERVAL = 19;
	static final int WEAK_LOWER = 20;
	static final int FDM = 22;
	static final int WEAK_DELTA=24;
	static final int INTERVAL_FDM=25;
	static final int INTERVAL_BOUNDARY=26;

	static final int NN = 15; // fuzzy-rough nearest neighbour classification
	static final int FNN = 16; // traditional fuzzy knn (uses parameter q)
	static final int FRNN = 17; // fuzzy-rough ownership knn (uses parameter q)
	static final int VQNN = 18;


	static Random rand = new Random();
	static final int RANDOM_REDUCT = 21;
	static int randomSize = 3; // the size of the randomly-generated reduct

	static float q = 3; // weighting for fuzzy knn
	static int K = -1; // k nearest neighbours value
	static double m = 0; // type-2 FRFS parameter for similarity relation
	static final double MISSING = Double.NaN;//-123456789;
	static boolean corrupt = false;
	static double corruptValue = 1; // probability of missing value
	static int countMissing = 0; // the number of (introduced) missing values

	static boolean visualise = false;

	// parameters for the CORNELISA fuzzy similarity relation
	static double alpha_c = 5;
	static double beta_c = 1.2;
	static double alpha_d = 5;
	static double beta_d = 1.2;

	static String toClassify = null; // dataset containing objects to classify
	static boolean outputConfusionMatrix=false;
	static boolean LOOCV=false;

	static boolean verbose = false;
	static int similarity = RSys2.TRIANGULAR2;
	static int dec_similarity = RSys2.EQUIVALENCE; // default is crisp
	// equivalence
	static boolean noTransitive = true;
	static boolean fuzzyDecision = false;
	static int OPTIMISE = 1;
	static String reduct = "";
	static boolean test = false;
	static boolean test2 = false;
	static boolean coreReduct = false;
	static boolean genetic = false;
	static boolean ACO = false;
	static boolean reverse = false;
	static boolean average = false;
	static double alpha = 1;
	static int population = 100;
	static int generations = 100;
	static double mutation = 0.05;
	static double crossover = 0.1;
	static int iterations;
	static int ants;
	static double antAlpha;
	static double antBeta;
	static int updateType;

	static double alpha_l = 0.1;
	static double beta_l = 0.6;
	static double alpha_u = 0.2;
	static double beta_u = 1;

	static boolean reduceAndClassify = false;

	static String outputFile = null; // where to output the reduced dataset
	static boolean WEKA = false; // is the data in the WEKA format?
	static boolean reduce = false; // do we want to output the reduced dataset?

	static String relationName;
	static ArrayList<String> relationAttributes = new ArrayList<String>();
	static int COMPOSITION = 2; // defines which tnorm to use when performing
	// relation composition

	public final static void main(String[] args) throws Exception {
		String filename;
		// set default arguments

		FuzzySet.CONNECT = 2; // default

		if (args.length == 0) {
			help();
			System.exit(0);
		}
		filename = args[0];
		command = BOUNDARY;

		int arglength = args.length; // minus the filename
		int count = 1; // don't consider the filename

		// sort out the arguments
		while (count < arglength) {
			count += handleParam(args, count);
		}

		switch (command) {
		case BOUNDARY:
			System.err.println("<== Fuzzy boundary FS ==>");
			break;
		case BOUNDARY_ENTROPY:
			System.err
			.println("<== Fuzzy boundary FS with fuzzy entropy evaluation==>");
			break;
		case LOWER:
			System.err.println("<== Fuzzy-rough FS ==>");
			break;
		case WEAK_LOWER:
			System.err.println("<== Fuzzy-rough FS (weak) ==>");
			break;
		case DISCERNIBILITY:
			System.err
			.println("<== Fuzzy-rough discernibility matrix (full) ==>");
			break;
		case FDM:
			System.err.println("<== Fuzzy-rough discernibility function ==>");
			break;
		case INTERVAL_FDM:
			System.err.println("<== Interval-valued fuzzy-rough discernibility function ==>");
			break;
		case INTERVAL_BOUNDARY:
			System.err.println("<== Interval-valued boundary region ==>");
			break;
		case CORE:
			System.err.println("<== Fuzzy-rough core ==>");
			break;
		case ENTROPY_REDUCT:
			System.err.println("<== Fuzzy entropy FS ==>");
			break;
		case GAIN_RATIO:
			System.err.println("<== Fuzzy gain ratio FS ==>");
			break;
		case DELTA:// slezak's measure
			System.err.println("<== Slezak's Delta Measure FS ==>");
			break;
		case WEAK_DELTA:// slezak's measure
			System.err.println("<== Slezak's Delta Measure FS (weak) ==>");
			break;
		case CORNELIS:
			System.err.println("<== Cornelis' Alpha Measure FS ==>");
			System.err.println("Alpha = " + alpha);
			break;
		case VQRS:
		case VQRS2:
			System.err.println("<== VQRS FS ==>");
			System.err.println("Alpha = " + alpha_u + " beta = " + beta_u);
			break;
		case ORIGINAL_FRFS:
			System.err.println("<== ORIGINAL FRFS ==>");
			System.err.println("(uses fuzzy similarity)");
			break;
		case NN:
			System.err.println("<== Fuzzy-rough NN ==>");

			break;
		case FNN:
			System.err.println("<== Fuzzy NN ==>");
			break;
		case INTERVAL:
			System.err.println("<== FRFS-II ==>");
			break;
		case VQNN:
			System.err.println("<== Fuzzy VQNN ==>");
			System.err.println("alpha_u = " + alpha_u + " beta_u = " + beta_u);
			System.err.println("alpha_1 = " + alpha_l + " beta_l = " + beta_l);
			break;
		case FRNN:
			System.err.println("<== Fuzzy-rough ownership NN ==>");
			break;
		case RANDOM_REDUCT:
			System.err.println("<== Random reduct ==>");
		}
		if (genetic)
			System.err.println("GA-based search");
		else if (ACO)
			System.err.println("ACO-based search");

		if (verbose)
			System.err.println("verbose");

		BufferedReader in = null;
		String line = null;

		// construct dataset
		try {
			in = new BufferedReader(new FileReader(filename));
			line = in.readLine();
		} catch (Exception e) {

			help();
			System.err.println(e);
			System.exit(1);
		}
		Matrix data = null;
		int cols = 0;
		int rows = 0;
		StringTokenizer st;
		String tok;


		// do some extra things if a WEKA dataset is given
		if (filename.endsWith(".arff")) {
			System.err.println("WEKA file format");
			WEKA = true;
			relationName = line;

			line = in.readLine();

			while (!line.equalsIgnoreCase("@DATA")) {
				if (line.startsWith("@ATTRIBUTE")
						|| line.startsWith("@attribute")) {
					relationAttributes.add(line);
				}
				line = in.readLine();
			}
			line = in.readLine();
			st = new StringTokenizer(line, " ,\t");
			while (st.hasMoreTokens()) {
				st.nextToken();
				cols++;
			}

			while (line != null && line.length() > 0) {
				rows++;
				line = in.readLine();
			}
			in.close();

			in = new BufferedReader(new FileReader(args[0]));
			data = new Matrix(rows, cols);
			line = in.readLine();
			while (!line.equalsIgnoreCase("@DATA")) {
				line = in.readLine();
			}

			readData(in,data,true);


		} else {
			st = new StringTokenizer(line, " ,\t");

			while (st.hasMoreTokens()) {
				st.nextToken();
				cols++;
			}

			while (line != null && line.length() > 0) {
				rows++;
				line = in.readLine();
			}
			in.close();

			in = new BufferedReader(new FileReader(args[0]));
			data = new Matrix(rows, cols);

			readData(in,data,true);

		}
		in.close();
		if (corrupt) {
			System.err.print("Corrupted data\nNumber of missing values: ");
			System.out.print(countMissing+"\t");
			System.err.println();
		}
		int objects = rows;
		int attributes = cols;

		Matrix data2 = null;

		int cols2 = 0;
		int rows2 = 0;

		if (!visualise
				&& (command == NN || command == FNN || command == FRNN || command == VQNN)) {
			// construct dataset for classification
			try {
				in = new BufferedReader(new FileReader(toClassify));
				line = in.readLine();
			} catch (Exception e) {
				help();
				System.err.println(e);
				System.exit(1);
			}

			st = new StringTokenizer(line, " ,\t\n");

			while (st.hasMoreTokens()) {
				st.nextToken();
				cols2++;
			}

			while (line != null && line.length() > 0) {
				rows2++;
				line = in.readLine();
			}
			in.close();

			in = new BufferedReader(new FileReader(toClassify));
			data2 = new Matrix(rows2, cols2);

			readData(in,data2,false);

			/*
			line = in.readLine();

			for (int i = 0; i < rows; i++) {
				st = new StringTokenizer(line, " ,\t\n");
				for (int j = 0; j < cols; j++) {
					tok = st.nextToken();
					double val;
					try {
						if (tok.equals("?"))
							val = 0;
						else
							val = Double.valueOf(tok).doubleValue();
					} catch (NumberFormatException e) {
						val = (double) tok.hashCode();
					}
					data2.setCell(i, j, val);
				}
				line = in.readLine();
				if (line == null)
					break;
			}*/
			in.close();
		}

		System.err.println(attributes + " features in dataset");
		System.err.println(objects + " objects in dataset\n");

		System.err.print("Connectives: ");
		switch (FuzzySet.CONNECT) {
		case FuzzySet.MINMAX:
			System.err.println("Max/Min");
			break;
		case FuzzySet.LIMITED:
		default:
			FuzzySet.CONNECT = FuzzySet.LIMITED;
		System.err.println("Lukasiewicz");
		break;
		case FuzzySet.ALGEBRAIC:
			System.err.println("Algebraic");
			break;
		case FuzzySet.TM:
			System.err.println("Tm");
			break;
		}

		System.err.print("Composition: ");
		switch (COMPOSITION) {
		case FuzzySet.MINMAX:
			System.err.println("Max/Min");
			break;
		case FuzzySet.LIMITED:
		default:
			COMPOSITION = FuzzySet.LIMITED;
		System.err.println("Lukasiewicz");
		break;
		case FuzzySet.ALGEBRAIC:
			COMPOSITION = FuzzySet.ALGEBRAIC;
			System.err.println("Algebraic");
			break;
		case FuzzySet.TM:
			COMPOSITION = FuzzySet.TM;
			System.err.println("Tm");
			break;
		}

		System.err.print("Similarity: ");
		switch (similarity) {
		case RSys2.GAUSSIAN:
			System.err.println("Gaussian");
			break;
		case RSys2.TRIANGULAR:
			System.err.println("Triangular 1");
			break;
		case RSys2.TRIANGULAR2:
		default:
			similarity = RSys2.TRIANGULAR2;
		System.err.println("Triangular 2");
		break;
		case RSys2.EQUIVALENCE:
			System.err.println("Crisp equivalence");
			break;
		case RSys2.TRIANGULAR3:
			System.err.println("Triangular 3 (Cornelis)");
			break;
		case RSys2.CORNELISA:
			System.err.println("Cornelis A, alpha=" + alpha_c + ", beta="
					+ beta_c);
			break;
		}
		System.err.print("Decision similarity: ");
		switch (dec_similarity) {
		case RSys2.GAUSSIAN:
			System.err.println("Gaussian");
			break;
		case RSys2.TRIANGULAR:
			System.err.println("Triangular 1");
			break;
		case RSys2.TRIANGULAR2:
			System.err.println("Triangular 2");
			break;
		case RSys2.EQUIVALENCE:
		default:
			dec_similarity = RSys2.EQUIVALENCE;
		System.err.println("Crisp equivalence");
		break;
		case RSys2.TRIANGULAR3:
			System.err.println("Triangular 3 (Cornelis)");
			break;
		case RSys2.CORNELISA:
			System.err.println("Cornelis A, alpha=" + alpha_d + ", beta="
					+ beta_d);
			break;

		}
		if ((genetic || ACO || reverse) && (OPTIMISE == 2 || OPTIMISE == 1)) {
			System.err
			.println("*** option -opt "
					+ OPTIMISE
					+ " not compatible with this search method - using -opt 3 ***");
			OPTIMISE = 3;
		}
		System.err.println("Optimise: " + OPTIMISE);

		long start = System.currentTimeMillis();

		int temp1 = similarity;
		int temp2 = COMPOSITION;
		int temp3 = FuzzySet.CONNECT;

		RSys2 sys = new RSys2(data, objects, verbose, similarity, noTransitive,
				alpha_u, beta_u, alpha_l, beta_l);
		// System.gc();

		System.err.println("-------------------------");
		Subset finalReduct = null;

		if (genetic) {

			System.err.println("[pop = " + population + ", gens = "
					+ generations + ", mut = " + mutation + ", cross = "
					+ crossover + "]");

			GeneticSearch gen = new GeneticSearch(sys, objects, attributes,
					verbose, population, generations, mutation, crossover,
					alpha);
			finalReduct = gen.run();
		} else if (ACO) {
			System.err.println("[its = " + iterations + ", ants = " + ants
					+ ", alpha = " + antAlpha + ", beta = " + antBeta
					+ ", update = " + updateType + "]");
			AntSearch antSearch = new AntSearch(sys, objects, attributes,
					verbose, iterations, antAlpha, antBeta, ants, updateType,
					alpha);
			finalReduct = antSearch.run();
		} else {
			switch (command) {
			case FDM:
			case CORNELIS:
			case INTERVAL:
			case INTERVAL_FDM: case INTERVAL_BOUNDARY:
			case LOWER:
			case WEAK_LOWER:
			case WEAK_DELTA:
			case ORIGINAL_FRFS:
			case VQRS:
			case VQRS2:
			case BOUNDARY:
			case ENTROPY_REDUCT:
			case GAIN_RATIO:
			case DELTA:
			case BOUNDARY_ENTROPY:
				if (coreReduct)
					finalReduct = sys.coreReduct(alpha);
				else if (reverse)
					finalReduct = sys.reverseReduct(alpha);
				else
					finalReduct = sys.quickReduct2(null, alpha);
				break;
			case DISCERNIBILITY: // output fuzzy clauses
				sys.fuzzyDiscernibility();
				break;
			case ISREDUCT:
				in = new BufferedReader(new FileReader(reduct));
				Subset candidate = new Subset(cols);
				line = in.readLine();
				st = new StringTokenizer(line, " ,}{");
				while (st.hasMoreTokens()) {
					tok = st.nextToken();
					try {
						int val = Integer.parseInt(tok);
						candidate.add(val);
					} catch (Exception e) {
					}
				}
				in.close();

				sys.isReduct(candidate);
				break;
			case RANDOM_REDUCT:
				if (randomSize <= 0 || randomSize > (cols - 1))
					randomSize = cols - 1;
				finalReduct = sys.randomReduct(randomSize);
				break;
			case CORE:
				sys.computeCore();
				break;
			case NN:
			case FNN:
			case FRNN:
			case VQNN:
				finalReduct = null;
				int com = command;
				command = LOWER;// need to alter this to make it changeable by
				// the user
				/*
				 * similarity = RSys2.TRIANGULAR2; COMPOSITION =
				 * FuzzySet.LIMITED; FuzzySet.CONNECT = FuzzySet.LIMITED;
				 */

				if (K < 1 || K > rows)
					K = rows;
				System.err.println("Using K = " + K);

				if (reduceAndClassify) {
					if (coreReduct)
						finalReduct = sys.coreReduct(alpha);
					else if (reverse)
						finalReduct = sys.reverseReduct(alpha);
					else
						finalReduct = sys.quickReduct2(null, alpha);

				}
				command = com;
				similarity = temp1;
				COMPOSITION = temp2;
				FuzzySet.CONNECT = temp3;

				if (visualise) {
					// rows2 = (num_vals1+1)*(num_vals2+1); //no of data points
					num_vals1++;
					num_vals2++;

					rows2 = (num_vals1) * (num_vals2);
					cols2 = 3; // final column = decision attr and not used
					data2 = new Matrix(rows2, cols2);

					double inc1 = sys.attrDifference[0]
					                                 / ((double) (num_vals1 - 1));
					double inc2 = sys.attrDifference[1]
					                                 / ((double) (num_vals2 - 1));

					double start1 = sys.min[0];
					double start2 = sys.min[1];
					int counter = 0;
					String labels_top = "";
					labels_vert = new String[num_vals1];

					// top axis=attribute 2, vertical is attribute 1
					for (int a1 = 0; a1 < num_vals1; a1++) {
						labels_vert[a1] = String.valueOf(start1);
						start2 = sys.min[1];
						labels_top = "";

						for (int a2 = 0; a2 < num_vals2; a2++) {
							// System.err.println(counter+" "+a1+" "+a2+"
							// "+start1+" "+start2);
							data2.setCell(counter, 0, start1);
							data2.setCell(counter, 1, start2);
							data2.setCell(counter, 2, 1);
							counter++;
							if (a2 == num_vals2 - 1) {
								labels_top += start2;
							} else
								labels_top += start2 + ", ";
							start2 += inc2;
						}
						start1 += inc1;
					}
					System.out.println(" ," + labels_top);
					System.out.print(labels_vert[0] + ", ");
				}

				sys.classify(data2, rows2, finalReduct);
				break;
			}
		}

		if (reduce)
			reduce(finalReduct, rows, cols, data);

		float time = (float) (System.currentTimeMillis() - start);
		System.err.println("Time taken = " + (time / 1000) + " secs");
	}

	static String[] labels_vert;
	static int num_vals1 = 100;
	static int num_vals2 = 100;
	static int decisionClass = 0;

	// deal with the argument parameters
	public final static int handleParam(String[] args, int count) {
		int ret = 0;
		try {
			if (args[count].equalsIgnoreCase("-l")) {
				command = LOWER; // average=true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-l2")) {
				command = WEAK_LOWER; // average=true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-i")) {
				command = INTERVAL; // average=true;
				m = (double) (Double.valueOf(args[count + 1]));
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-b")) {
				command = BOUNDARY; // average=true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-b2")) {
				command = INTERVAL_BOUNDARY; // average=true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-be")) {
				command = BOUNDARY_ENTROPY;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-e")) {
				command = ENTROPY_REDUCT;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-gr")) {
				command = GAIN_RATIO;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-delta")) {
				command = DELTA;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-delta2")) {
				command = WEAK_DELTA;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-alpha")) {
				alpha = (double) (Double.valueOf(args[count + 1]));
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-f")) {
				command = CORNELIS;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-rr")) {
				command = RANDOM_REDUCT;
				randomSize = Integer.parseInt(args[count + 1]);
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-vqrs")) {
				command = VQRS;
				alpha_u = (double) (Double.valueOf(args[count + 1]));
				beta_u = (double) (Double.valueOf(args[count + 2]));
				ret = 3;
			} else if (args[count].equalsIgnoreCase("-vqnn")) {
				command = VQNN;
				alpha_u = (double) (Double.valueOf(args[count + 1]));
				beta_u = (double) (Double.valueOf(args[count + 2]));
				alpha_l = (double) (Double.valueOf(args[count + 3]));
				beta_l = (double) (Double.valueOf(args[count + 4]));
				toClassify = args[count + 5];
				ret = 6;
			} else if (args[count].equalsIgnoreCase("-vqrs2")) { // weak version
				command = VQRS2;
				alpha_u = (double) (Double.valueOf(args[count + 1]));
				beta_u = (double) (Double.valueOf(args[count + 2]));
				ret = 3;
			} else if (args[count].equalsIgnoreCase("-f")) {
				command = ORIGINAL_FRFS;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-GA")) {
				genetic = true;
				ACO = false;
				population = Integer.parseInt(args[count + 1]);
				generations = Integer.parseInt(args[count + 2]);
				mutation = (double) (Double.valueOf(args[count + 3]));
				crossover = (double) (Double.valueOf(args[count + 4]));
				ret = 5;
			} else if (args[count].equalsIgnoreCase("-ACO")) {
				ACO = true;
				genetic = false;
				iterations = Integer.parseInt(args[count + 1]);
				ants = Integer.parseInt(args[count + 2]);
				antAlpha = (double) (Double.valueOf(args[count + 3]));
				antBeta = (double) (Double.valueOf(args[count + 4]));
				updateType = Integer.parseInt(args[count + 5]);
				ret = 6;
			} else if (args[count].equalsIgnoreCase("-v")) {
				verbose = true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-n")) {
				noTransitive = false;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-s")) {
				similarity = Integer.parseInt(args[count + 1]);
				ret = 2;

				if (similarity == RSys2.CORNELISA) {
					alpha_c = (double) Double.valueOf(args[count + 2]);
					beta_c = (double) Double.valueOf(args[count + 3]);
					ret = 4;
				}
			} else if (args[count].equalsIgnoreCase("-c")) {
				// connectives
				FuzzySet.CONNECT = Integer.parseInt(args[count + 1]);
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-comp")) {
				// connectives
				COMPOSITION = Integer.parseInt(args[count + 1]);
				FuzzySet.COMPOSE = COMPOSITION;
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-opt")) {
				OPTIMISE = Integer.parseInt(args[count + 1]);
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-d")) {
				dec_similarity = Integer.parseInt(args[count + 1]);
				ret = 2;

				if (dec_similarity == RSys2.CORNELISA) {
					alpha_d = (double) Double.valueOf(args[count + 2]);
					beta_d = (double) Double.valueOf(args[count + 3]);
					ret = 4;
				}
			} else if (args[count].equalsIgnoreCase("-h")
					|| args[count].equalsIgnoreCase("-help")) {
				help();
				System.exit(1);
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-discern")) {
				command = DISCERNIBILITY;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-corrupt")) {
				corrupt = true;
				//insert this proportion of missing values randomly
				corruptValue = 1-(double) (Double.valueOf(args[count + 1])); 
				rand.setSeed(Long.valueOf(args[count + 2]));
				ret = 3;
			} else if (args[count].equalsIgnoreCase("-core")) {
				command = CORE;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-vis")) {
				visualise = true;
				decisionClass = Integer.parseInt(args[count + 1]);
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-reverse")) {
				reverse = true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-fdm")) {
				command = FDM;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-fdm2")) {
				command = INTERVAL_FDM;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-average")) {
				average = true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-test")) {
				test = true;
				command = TEST;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-test2")) {
				test2 = true;
				command = TEST;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-isreduct")) {
				command = ISREDUCT;
				reduct = args[count + 1];
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-reduce")) {
				reduce = true;
				// outputFile = args[count+1];
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-reduceAndClassify")) {
				reduceAndClassify = true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-k")) {
				K = Integer.parseInt(args[count + 1]);
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-q")) { // weighting for fuzzy knn
				q = (float) (Float.valueOf(args[count + 1]));
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-classify")) {
				command = NN;
				toClassify = args[count + 1];
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-fnn")) {
				command = FNN;
				toClassify = args[count + 1];
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-conf")) {
				outputConfusionMatrix=true;
				ret=1;
			} else if (args[count].equalsIgnoreCase("-loocv")) {
				LOOCV=true;
				ret=1;
			} else if (args[count].equalsIgnoreCase("-frnn")) {
				command = FRNN;
				toClassify = args[count + 1];
				ret = 2;
			} else if (args[count].equalsIgnoreCase("-coreReduct")) {
				coreReduct = true;
				ret = 1;
			} else if (args[count].equalsIgnoreCase("-fuzzyDec")) {
				fuzzyDecision = true;
				ret = 1;
			} else {
				System.err.println("Unrecognised command: " + args[count]
				                                                   + "\n");
				help();
				ret = 1;
				System.exit(1);
			}
		} catch (Exception e) {
			System.err.println();
			System.err.println(e);
			System.err.println();
		}
		return ret;
	}

	public final static void help() {
		System.err.println("<== Fuzzy rough set methods ==>");
		System.err.println("Usage: java frfs2 <dataset> <options>\n");
		System.err.println("<options>");
		System.err
		.println("\t-b\t\tFuzzy boundary region based search (default)");
		System.err.println("\t-be\t\tFuzzy boundary region with fuzzy entropy");
		System.err.println("\t-l\t\tFuzzy lower approximation based search");
		System.err.println("\t-e\t\tFuzzy entropy based search");
		System.err.println("\t-gr\t\tFuzzy gain ratio based search");
		System.err.println("\t-fdm\t\tFuzzy discernibility based search");
		System.err.println("\t-vqrs <alpha> <beta>\tVQRS");
		System.err.println("\t-vqrs2 <alpha> <beta>\tVQRS2");
		System.err.println("\t-delta\t\tSlezak's delta measure based search");
		System.err.println("\t-f\tCornelis' alpha measure based search");
		System.err.println("\t-alpha <val>\tAlpha, for alpha-decision reducts");
		System.err.println("\t-GA <pop> <gen> <mut> <crs>  GA-based search");
		System.err
		.println("\t-ACO <its> <ants> <alpha> <beta> <update>  ACO-based search");
		System.err
		.println("\t-rr <val>\t Random reduct, containing <val> conditional feature(s)");
		System.err.println("\t-n\t\tCompute fuzzy transitive closure");

		System.err.println();
		System.err.println("\t------- Nearest Neighbours options -------");
		System.err
		.println("\t-k <val>\t\tSpecify the number of nearest neighbours");
		System.err
		.println("\t-fnn <test data>\tFuzzy NN, classify the test datasets specified");
		System.err.println("\t-classify <test data>\tFRNN");
		System.err.println("\t-frnn <test data>\tFuzzy rough ownership NN");
		System.err.println("\t------------------------------------------\n");

		System.err.println("\t-s <val>\tFuzzy similarity");
		System.err.println("\t\t\t 0 = Gaussian");
		System.err.println("\t\t\t 1 = Triangular 1");
		System.err.println("\t\t\t 2 = Triangular 2 (default)");
		System.err.println("\t\t\t 3 = Crisp equivalence");
		System.err.println("\t\t\t 4 = Triangular 3");
		System.err.println("\t\t\t 5 = Cornelis A");
		System.err.println("\t\t\t 6 = Cornelis B");
		System.err.println("\t\t\t 7 = Cornelis C");

		System.err
		.println("\t-d <sim>\t Use <sim> as fuzzy decision similarity (default = crisp)\n");
		System.err.println("\t-c <val>\tFuzzy connectives");
		System.err.println("\t\t\t 1 = Max/Min");
		System.err.println("\t\t\t 2 = Lukasiewicz (default)");
		System.err.println("\t\t\t 3 = Algebraic");
		System.err.println("\t\t\t 5 = Tm");
		System.err.println("\t-comp <val>\tFuzzy connectives for relation composition (default = Lukasiewicz)");
		System.err.println();

		System.err.println("\t-opt <val>\tLevels of optimisation");
		System.err.println("\t\t\t 0 = Compute full relations beforehand");
		System.err.println("\t\t\t 1 = Compute partial relations (default)");
		System.err.println("\t\t\t 2 = Compute relations on-the-fly");

		System.err.println("\t-reduce\t\tReduce the data after finding the reduct");

		System.err.println("\t-discern\tCalculate fuzzy discernibility matrix");
		System.err.println("\t-core\t\tCalculate core of the dataset");
		System.err.println("\t-coreReduct\tStart search using the core");
		System.err
		.println("\t-isreduct <red>\tCalculates gamma for subset found in file <red>");

		System.err.println("\t-v\t\tVerbose mode");
		System.err.println("\t-h\t\tThis help information");

	}

	// output the reduced dataset
	public static void reduce(Subset reduct, int rows, int cols, Matrix data) {
		if (reduct == null) {
			System.err.println("No reduct found... terminating.");
			System.exit(1);
		}
		StringTokenizer st;
		String line = "";
		boolean[] crisp = new boolean[reduct.cardinality()];
		int reductIndex = 0;
		if (WEKA) {
			System.out.println(relationName);
			System.out.println();

			Iterator<String> it = relationAttributes.iterator();
			int index = 0;

			while (it.hasNext()) {
				line =  it.next();

				if (reduct.contains(index)) {
					st = new StringTokenizer(line, " \t{,");
					st.nextToken();
					st.nextToken();

					String token = st.nextToken();
					if (token.equalsIgnoreCase("real")
							|| token.equalsIgnoreCase("numeric"))
						crisp[reductIndex] = false;
					else
						crisp[reductIndex] = true;

					reductIndex++;
					System.out.println(line);
				}

				index++;
			}
			System.out.println();

			System.out.println("@DATA");
		}
		double value = 0;
		String end = "";

		for (int i = 0; i < rows; i++) {
			reductIndex = 0;
			for (int j = 0; j < cols; j++) {
				if (reduct.contains(j)) {
					value = data.getCell(i, j);

					if (j == cols - 1) {
						end = "\n";
					}
					else
						end = ", ";

					if (crisp[reductIndex]) {
						System.out.print(((int)value) + end);
					}
					else if (classMap.size()>0&&j == cols - 1) {
						System.out.print(classMap.get(value) + end);
					}
					else {
						System.out.print(value + end);
					}
					reductIndex++;
				}
			}

		}
		//System.out.println();
	}

	static HashMap<Double,String> classMap = new HashMap<Double,String>();

	private static void readData(BufferedReader in, Matrix data, boolean classes) throws Exception {
		String line = in.readLine();
		StringTokenizer st;
		String tok;


		for (int i = 0; i < data.numRows(); i++) {
			st = new StringTokenizer(line, " ,\t\n");
			for (int j = 0; j < data.numCols(); j++) {
				tok = st.nextToken();
				double val;
				if (tok.equals("?")) {
					val = MISSING;
				} else {
					try {
						val = Double.valueOf(tok).doubleValue();
					} catch (Exception e) {
						val = (double)tok.hashCode();				
					}

					if (classes && j==data.numCols()-1) {
						//keep track of class labels
						if (!classMap.containsKey(val)) {
							classMap.put(val,tok);
						}
					}
				}
				if (corrupt) { //artificially corrupt the data
					if (j != data.numCols() - 1 && rand.nextDouble() > corruptValue) {
						val = MISSING;
						countMissing++;
					}
				}
				data.setCell(i, j, val);
			}
			line = in.readLine();
			if (line == null)
				break;
		}
	}
}
