package search;
/*this class will simplify a given fuzzy clause database
  it can do this in the following ways:
  1) remove duplicates (implemented)
  2) remove clauses that are supersets of others (not implemented yet)
*/
import java.util.StringTokenizer;
import java.io.*;

import frfs2.Matrix;

public class Simplify {
    public static void main(String[] args) throws Exception{
	if (args.length!=1) {
	    System.err.println("Usage: java Simplify <clause dataset>");
	    System.exit(1);
	}
	int rows=0,cols=0;
	
	BufferedReader in = new BufferedReader(new FileReader(args[0]));
	String line = in.readLine();
	StringTokenizer st = new StringTokenizer(line," ,");
	
    while(st.hasMoreTokens()) {
      st.nextToken();
      cols++;
    }

    while(line!=null&&line.length()>0) {
      rows++;
      line = in.readLine();
    }
    
    in = new BufferedReader(new FileReader(args[0]));

	Matrix data = new Matrix(rows,cols);
	line = in.readLine();
	String tok;

	for (int i=0;i<rows;i++) {
	    st = new StringTokenizer(line," ,");
	    for (int j=0;j<cols;j++) {
		tok = st.nextToken();
		double val;
		if (tok.equals("?")) val=0;
		else val = Double.valueOf(tok).doubleValue();
		data.setCell(i,j,val);
	    }
	    line = in.readLine();
	    if (line==null) break;
	}
	in.close();

	boolean removed[] = new boolean[rows];
	for (int i=0;i<removed.length;i++) {
	    removed[i]=false;
	}

	//remove duplicate entries
	for (int o1=0;o1<rows;o1++) {
	    if (!removed[o1]) {
		for (int o2=o1+1;o2<rows;o2++) {
		    if (!removed[o2]) {
			boolean same=true;
			for (int a=0;a<cols;a++) {
			    if (data.getCell(o1,a)!=data.getCell(o2,a)) {
				same=false;
				break;
			    }
			}
			if (same) {removed[o2]=true;}
		    }
		}
	    }
	}

	//print data
	for (int o=0;o<rows;o++) {
	    //System.out.print(removed[o]+" ");
	    if (!removed[o]) {
		for (int a=0;a<cols;a++) {
		    System.out.print(data.getCell(o,a)+" ");
		}
		System.out.println();
	    }
	}
    }
}
