package set;
import java.util.BitSet;

//represents a feature subset
public class Subset {
	BitSet subset;
	
	public Subset(int size) {
		subset = new BitSet(size);
	}
	
	public Subset(BitSet s) {
		subset = s;
	}
	
	public int cardinality() {
		return subset.cardinality();
	}
	
	public void remove(int feature) {
		subset.clear(feature);
	}
	
	public boolean contains(int feature) {
		return subset.get(feature);
	}
	
	public void add(int feature) {
		subset.set(feature);
	}
	
	public int nextFeature(int index) {
		return subset.nextSetBit(index);
	}
	
	public void union(Subset other) {
		subset.or(other.subset);
	}
	
	public void intersect(Subset other) {
		subset.and(other.subset);
	}
	
	public Object clone() {
		return new Subset((BitSet)subset.clone());
	}
	
	public String toString() {
		return subset.toString();
	}
}
